function [Dxy,Ixy,Iyx] = CMIc(X,Y,t,tau)

%  Input:   X, Y time series;
%           order: order of permuation entropy,  ord!*ord!*ord!<N, N is length of series X and Y:
%           t: delay time of permuation entropy, default t=1

%           tau: delay time in conditional mutual information

% Output: 
%           Ixy:  conditional mutual informaion (I(X,Dy|Y)) ;
%           Ixy:  conditional mutual informaion (I(Y,Dy|X)) ;

%           Dxy:  The direcionality of the coupling between the X and Y, X->Y; 
%                     if Out.Dxy > 0, means X->Y, otherwise X<-Y; 
          

%% referrence: Estimating coupling direction between neuronal populations
%% with permutation conditional mutual information, NeuroImage, 2010, 52:497-507 

%  revise time: May 27 2012, Yan, Jiaqing, Ouyang, Gaoxiang and Li, Xiaoli 




% difference of X and Y;
% DeltaX = X(1:(end-tau))-X((1+tau):end);
% DeltaY = Y(1:(end-tau))-Y((1+tau):end);

DeltaX = X((1+tau):end);
DeltaY = Y((1+tau):end);

X1 = X(1:(end-tau));
Y1 = Y(1:(end-tau));

Ixy = pecmi(X1,DeltaY, Y1,t);
Iyx = pecmi(Y1,DeltaX, X1,t);

Dxy=0;
if Ixy~=0
    Dxy=(Ixy-Iyx)/(Ixy+Iyx);
end
