function cmi = pecmi(x,y,z,t)

% cmi  conditional mutual informaion (I(x,y|z)) ;
% 
%  Input:   x,y,z  time series;
%           t: delay time of order pattern analysis, default t=1
%
%           order: dimension of order pattern analysis (In this code, parameter order is set to 3.)  
%                  ord!*ord!*ord!<N, N is length of series x, y and z:

if ~exist('t')|isempty(t),t=1;end

if ~libisloaded('pcmilib')
    loadlibrary('pcmi','pcmi.h','alias','pcmilib');
end

x_ary = libpointer('doublePtr',x);
y_ary = libpointer('doublePtr',y);
z_ary = libpointer('doublePtr',z);

calllib('pcmilib','PCMI',x_ary,y_ary,z_ary,length(x),t);

miz=calllib('pcmilib','GetZ');
mixz=calllib('pcmilib','GetXZ');
miyz=calllib('pcmilib','GetYZ');
mixyz=calllib('pcmilib','GetXYZ');

cmi = mixz+miyz-miz-mixyz;   % I(x,y|z)